#pragma once

#include <qwt_plot.h>
#include <qwt_plot_curve.h>
#include <qwt_plot_zoomer.h>
#include <qwt_plot_grid.h>
#include <qwt_plot_panner.h>
#include <qwt_plot_rescaler.h>
#include "HistoData.hpp"
#include "iDataProcessor.hpp"
#include <memory>
#include <QPointer>

class Mhisto: public QwtPlot
{
		Q_OBJECT
	public:
		Mhisto(QWidget *parent = 0);
		bool save_data();
		const HistoData &histo_data() const;
		void erase_data_store();
	public slots:
		void newBuffer(unsigned int *, int, int, long long);
		void set_accumulation(int);
		int init_data_processor();
	private:
		QwtPlotCurve *curv[CHANNELS];
		QPointer <QwtPlotRescaler> rescaler;
		QPointer <QwtPlotZoomer> zoomer;
		QPointer <QwtPlotPanner> panner;
		HistoData data_store;
		std::auto_ptr <iDataProcessor> data_processor_;
		bool accumulation;
	signals:
		void takeRates(QList <double>);
};

