#include "Mrates.h"
#include <string.h>
#include <scTDC.h>

Mrates::Mrates(QWidget *parent): QwtPlot(parent)
{
	setAxisScale(xBottom, 0.5, 1.5, 0);
	yScaleMax = 100.0;
	setAxisScale(yLeft, -0.5, yScaleMax, 0.0);
	grid = new QwtPlotGrid;
	grid->setPen(QPen(Qt::gray, 1, Qt::DashLine));
	grid->attach(this);

	setCanvasBackground(QColor(Qt::white));

	for (int i=0; i<2; i++) {
		curv[i] = new QwtPlotCurve(QString("curve") + QString::number(i+1));
		curv[i]->attach(this);
		curv[i]->setAxes(yLeft, xBottom);
		curv[i]->setStyle(QwtPlotCurve::Sticks);
	}
		curv[0]->setPen(QPen(QColor(255,0,0), 6.0, Qt::SolidLine, Qt::FlatCap, Qt::BevelJoin));
		curv[1]->setPen(QPen(QColor(0,255,0), 6.0, Qt::SolidLine, Qt::FlatCap, Qt::BevelJoin));

	setAxisTitle(QwtPlot::xBottom, "Channel");
	setAxisTitle(QwtPlot::yLeft, "Counts");

	replot();
}

void Mrates::newRates(QList <double> buf)
{
	statistics_t stat;
	memset(&stat, 0, sizeof(stat));
	sc_tdc_get_statistics(&stat);
	int size = buf.size();
	double *x = new double[size];
	double *x_ = new double[size];
	double *y = new double[size];
	double *y_ = new double[size];
	double maxRate = 0.0;
	for (int i=0; i<size; i++) {
		x_[i] = x[i] = double(i) +1.0;
		y[i] = buf.at(i);
		y_[i] = stat.counts_read[0][i];
		if (maxRate < buf.at(i)) {
			maxRate = buf.at(i);
		}
		if (maxRate < stat.counts_read[0][i]) {
			maxRate = stat.counts_read[0][i];
		}
	}
	curv[0]->setSamples(x_, y_, size);
	curv[1]->setSamples(x, y, size);
	setAxisScale(xBottom, 0.5, size + 0.5, 0);
	if ((maxRate > yScaleMax)||(maxRate < 0.3*yScaleMax)) {
		yScaleMax = maxRate*1.05;
		setAxisScale(yLeft, -0.5, yScaleMax, 0.0);
	}
	delete [] x;
	delete [] y;
	delete [] x_;
	delete [] y_;
	replot();
}
